Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java	(revision 3060)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java	(revision 3061)
@@ -1407,6 +1407,7 @@
 				connection.eval("setwd(\"" + userdir.getAbsolutePath().replace("\\", "/") + "\")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
 			}
 			
+			// set the libraries directory to install new R packages
 			File RLibrariesWorkspaceDirectory = new File(userdir, "libraries");
 			RLibrariesWorkspaceDirectory.mkdir();
 			if (!RLibrariesWorkspaceDirectory.exists()) {
@@ -1421,6 +1422,13 @@
 				rPackagesPath = rPackagesPath.replace("\\", "/"); //$NON-NLS-1$ //$NON-NLS-2$
 			}
 			
+			// set the default R repository
+			String repos = RPreferences.getInstance().getString(RPreferences.DEFAULT_REPOS);
+			if (repos.length() > 0) {
+				Log.fine("Set the 'repos' R option to " + repos);
+				connection.eval("options(repos=\"" + repos + "\")");//$NON-NLS-1$ //$NON-NLS-2$
+			}
+			
 			// set proxy configuration using detected system proxy if exists
 			SystemProxyDetector conf = new SystemProxyDetector();
 			this.initializeRWorkspaceConnectionConfiguration(conf);
Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java	(revision 3060)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java	(revision 3061)
@@ -70,7 +70,9 @@
 	 */
 	public static final String SHOW_EVAL_LOGS = "show_eval_logs"; //$NON-NLS-1$
 	
+	public static final String DEFAULT_REPOS = "default_repos";
 	
+	
 	/**
 	 * Gets the instance.
 	 * 
@@ -165,6 +167,7 @@
 			return;
 		}
 		
+		preferences.put(DEFAULT_REPOS, "https://cloud.r-project.org");
 		preferences.put(PATH_TO_EXECUTABLE, execFile.getAbsolutePath());
 		preferences.putBoolean(IS_MANDATORY, false);
 		preferences.put(SERVER_ADDRESS, "127.0.0.1");
Index: tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java
===================================================================
--- tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java	(revision 3060)
+++ tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java	(revision 3061)
@@ -10,12 +10,15 @@
 
 /**
  * Search engines manager.
+ * 
  * @author mdecorde
  *
  */
-//FIXME: useless class, the type and priority/order should be defined in org.txm.core.engines.EnginesManager extension point
+// FIXME: useless class, the type and priority/order should be defined in org.txm.core.engines.EnginesManager extension point
 public class SearchEnginesManager extends EnginesManager<SearchEngine> {
-
+	
+	private static final long serialVersionUID = 8476457980915443357L;
+	
 	/**
 	 * 
 	 * @return
@@ -23,7 +26,7 @@
 	public static SearchEngine getCQPSearchEngine() {
 		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine("CQP"); //$NON-NLS-1$
 	}
-
+	
 	/**
 	 * 
 	 * @return
@@ -39,19 +42,19 @@
 	public static SearchEngine getSearchEngine(String name) {
 		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine(name);
 	}
-
+	
 	@Override
 	public boolean fetchEngines() {
 		return this.fetchEngines(SearchEngine.EXTENSION_POINT_ID);
 	}
-
+	
 	@Override
 	public EngineType getEnginesType() {
 		return EngineType.SEARCH;
 	}
-
+	
 	public static List<SearchEngine> getAvailableEngines(CorpusBuild corpus) {
-		List<SearchEngine> availables = new ArrayList<SearchEngine>();
+		List<SearchEngine> availables = new ArrayList<>();
 		SearchEnginesManager em = (SearchEnginesManager) Toolbox.getEngineManager(EngineType.SEARCH);
 		for (String name : em.getEngines().keySet()) {
 			SearchEngine engine = em.getEngine(name);
Index: tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginePreferences.java
===================================================================
--- tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginePreferences.java	(revision 0)
+++ tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginePreferences.java	(revision 3061)
@@ -0,0 +1,41 @@
+package org.txm.searchengine.core;
+
+import org.osgi.service.prefs.Preferences;
+import org.txm.core.preferences.TXMPreferences;
+
+
+public class SearchEnginePreferences extends TXMPreferences {
+	
+	/**
+	 * contains the last bundle version setting the TreeTagger models directory
+	 */
+	public static final String DEFAULT_SEARCH_ENGINE = "default_search_engine"; //$NON-NLS-1$
+	
+	/**
+	 * if set, the available search engines are shown in TXM interfaces
+	 */
+	public static final String SHOW_SEARCH_ENGINES = "show_search_engines"; //$NON-NLS-1$
+	
+	/**
+	 * Gets the instance.
+	 * 
+	 * @return the instance
+	 */
+	public static TXMPreferences getInstance() {
+		if (!TXMPreferences.instances.containsKey(SearchEnginePreferences.class)) {
+			new SearchEnginePreferences();
+		}
+		return TXMPreferences.instances.get(SearchEnginePreferences.class);
+	}
+	
+	@Override
+	public void initializeDefaultPreferences() {
+		super.initializeDefaultPreferences();
+		
+		// Default preferences if no org.txm.udpipe.core fragment is found
+		Preferences preferences = this.getDefaultPreferencesNode();
+		
+		preferences.put(DEFAULT_SEARCH_ENGINE, "CQP");
+		preferences.putBoolean(SHOW_SEARCH_ENGINES, false);
+	}
+}

Index: tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 3060)
+++ tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 3061)
@@ -8,9 +8,9 @@
 Bundle-SymbolicName: org.txm.searchengine.cqp.rcp;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Bundle-Name: %Bundle-Name
-Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexpor
- t,org.txm.searchengine.cqp.core;bundle-version="1.1.0";visibility:=re
- export
+Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexport,
+ org.txm.searchengine.cqp.core;bundle-version="1.1.0";visibility:=reexport,
+ org.txm.searchengine.rcp;bundle-version="1.0.0";visibility:=reexport
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
 Bundle-Vendor: Textometrie.org
Index: tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/TokenizerClasses.java
===================================================================
--- tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/TokenizerClasses.java	(revision 3060)
+++ tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/TokenizerClasses.java	(revision 3061)
@@ -30,6 +30,7 @@
 import java.io.IOException;
 import java.lang.reflect.Field;
 import java.lang.reflect.Modifier;
+import java.util.Locale;
 import java.util.regex.Pattern;
 
 import javax.xml.parsers.ParserConfigurationException;
@@ -48,104 +49,133 @@
  */
 public class TokenizerClasses {
 	
+	public String lang;
+	
+	public TokenizerClasses(String lang) {
+		if (lang != null) {
+			this.lang = lang;
+		}
+		else {
+			this.lang = Locale.getDefault().getCountry();
+		}
+		reset();
+	}
+	
+	public TokenizerClasses() {
+		this(Locale.getDefault().getCountry());
+	}
+	
+	/**
+	 * Helper
+	 * 
+	 * @param projectScope
+	 * @return
+	 */
+	public static TokenizerClasses newTokenizerClasses(ProjectScope projectScope, String lang) {
+		TokenizerClasses tc = new TokenizerClasses();
+		tc.loadFromProject(projectScope);
+		tc.lang = lang;
+		return tc;
+	}
+	
 	//// ROOTS ? ////
-	public static boolean debug = false;
+	public boolean debug = false;
 	
 	/** The tag_all. */
-	public static String tag_all = null;
+	public String tag_all = null;
 	
 	/** The Weblex enclitics. */
-	public static String enclitics = null;
+	public String enclitics = null;
 	
-	public static String encliticsFR = null;
+	public String encliticsFR = null;
 	
 	/** The TT enclitics. */
-	public static String FClitic_en = null;
+	public String FClitic_en = null;
 	
-	public static String PClitic_fr = null;
+	public String PClitic_fr = null;
 	
-	public static String FClitic_fr = null;
+	public String FClitic_fr = null;
 	
-	public static String PClitic_it = null;
+	public String PClitic_it = null;
 	
-	public static String FClitic_gl = null;
+	public String FClitic_gl = null;
 	
 	/** The div_tags. */
-	public static String div_tags = null;
+	public String div_tags = null;
 	
 	/** The q_tags. */
-	public static String q_tags = null;
+	public String q_tags = null;
 	
 	/** The extraword_tags. */
-	public static String extraword1_tags = null;
+	public String extraword1_tags = null;
 	
 	/** The corr_tags_no_seg. */
-	public static String corr_tags_no_seg = null;
+	public String corr_tags_no_seg = null;
 	
 	/** The word_tags. */
-	public static String word_tags = null;
+	public String word_tags = null;
 	
 	/** the element to create when a word is created */
-	public static String word_element_to_create = null;
+	public String word_element_to_create = null;
 	
 	/** The intraword_tags. */
-	public static String intraword_tags = null;
+	public String intraword_tags = null;
 	
 	/** The punct_quotes. */
-	public static String punct_quotes = null;
+	public String punct_quotes = null;
 	
 	/** The punct_strong1. */
-	public static String punct_strong1 = null;
+	public String punct_strong1 = null;
 	
 	/** The punct_strong2. */
-	public static String punct_strong2 = null;
+	public String punct_strong2 = null;
 	
 	/** The punct_paren_open1. */
-	public static String punct_paren_open1 = null;
+	public String punct_paren_open1 = null;
 	
 	/** The punct_paren_open2. */
-	public static String punct_paren_open2 = null;
+	public String punct_paren_open2 = null;
 	
 	/** The punct_paren_close1. */
-	public static String punct_paren_close1 = null;
+	public String punct_paren_close1 = null;
 	
 	/** The punct_paren_close2. */
-	public static String punct_paren_close2 = null;
+	public String punct_paren_close2 = null;
 	
 	/** The punct_weak. */
-	public static String punct_weak = null;
+	public String punct_weak = null;
 	
-	public static String entity = null;
+	public String entity = null;
 	
-	public static String seg_tags = null;
+	public String seg_tags = null;
 	
 	//// COMBINAISONS ////
 	
 	/** The corr_tags. */
-	public static String corr_tags = null;
+	public String corr_tags = null;
 	
 	/** The extraword_tags. */
-	public static String extraword_tags = null;
+	public String extraword_tags = null;
 	
 	/** The punct_strong. */
-	public static String punct_strong = null;
+	public String punct_strong = null;
 	
 	/** The punct_paren_open. */
-	public static String punct_paren_open = null;
+	public String punct_paren_open = null;
 	
 	/** The punct_paren_close. */
-	public static String punct_paren_close = null;
+	public String punct_paren_close = null;
 	
 	/** The punct_paren. */
-	public static String punct_paren = null;
+	public String punct_paren = null;
 	
 	/** The punct_all. */
-	public static String punct_all = null;
+	public String punct_all = null;
 	
 	/** The word_chars. */
-	public static String word_chars = null;
+	public String word_chars = null;
 	
-	public static TTest[] tests = {
+	public TTest[] tests = {
 			// new TTest(/\A(.*-)(je|m[eo]i|tu|t[eo]i|lui|luy|ilz|ils?|no?u?s|vo?u?s|on|leurs|ce|ci|là|elles?)(.*)\Z/),
 			// new TTest(/\A(.*)(-)()\Z/, "pon"),
 			// new TTest(/\A(.*)(Bande dessinée|eau de vie|machine à écrire|Moyen Âge|petit pois|poule d'eau|Avoir l'air|se rendre compte|faire semblant|prendre froid|s'en aller|Comme il faut|bon
@@ -173,16 +203,12 @@
 			// new TTest(/\A(.*)(\p{Ps}|\p{Pe}|\p{Pi}|\p{Pf}|\p{Po}|\p{S})(.*)\Z/, "pon")
 	};
 			
-	public static String whitespaces = null;
+	public String whitespaces = null;
 	
-	public static String regElision = null;
+	public String regElision = null;
 	
-	public static String regPunct = null;
+	public String regPunct = null;
 	
-	static {
-		reset(); // Initialize static fields
-	}
-	
 	// punct_strong1 = ".!?";
 	// punct_strong2 = "\\.\\.|\\.\\.\\.|…|\\|";
 	// punct_strong = "[$punct_strong1]|$punct_strong2";
@@ -197,7 +223,7 @@
 	// punct_all = "$punct_strong|$punct_paren|[$punct_weak]";
 	// word_chars = "[^ $punct_strong1$punct_paren_open1$punct_paren_close1$punct_weak]|&[^;]+;";
 	
-	public static void reset() {
+	public void reset() {
 		tag_all = "<[A-Za-z][^>]+>";
 		
 		div_tags = "TEI|text|front|body|div|div1|div2|div3|div4|div5|div6|back|head|trailer|p|ab|sp|speaker|list|notice|bibl|opener|dateline";
@@ -235,7 +261,7 @@
 		recombine();
 	}
 	
-	public static void recombine() {
+	public void recombine() {
 		corr_tags = "" + corr_tags_no_seg + "|" + seg_tags + "";
 		extraword_tags = "" + div_tags + "|" + q_tags + "|" + extraword1_tags + "";
 		punct_strong = "[" + punct_strong1 + "]|" + punct_strong2 + "";
@@ -254,7 +280,7 @@
 	 * @return the java.lang. object
 	 */
 	@Deprecated
-	public static void toDom(Document doc, Node parent) {
+	public void toDom(Document doc, Node parent) {
 		Element tokenizer = doc.createElement("tokenizer");
 		tokenizer.setAttribute("onlyThoseTests", "false");
 		parent.appendChild(tokenizer);
@@ -395,7 +421,7 @@
 	/**
 	 * Dump.
 	 */
-	public static void dump() {
+	public void dump() {
 		System.out.println("BRUT");
 		System.out.println("tag_all = " + tag_all + "");
 		System.out.println("enclitics = " + enclitics + "");
@@ -435,7 +461,7 @@
 		}
 	}
 	
-	public static boolean isValid() {
+	public boolean isValid() {
 		try {
 			Pattern.compile(tag_all);
 		}
@@ -699,7 +725,7 @@
 	 * @return
 	 */
 	@Deprecated
-	public static boolean loadFromNode(Element tokenizerElement) {
+	public boolean loadFromNode(Element tokenizerElement) {
 		// load params
 		String tmp_strong_punct = null;
 		NodeList params = tokenizerElement.getElementsByTagName("param");
@@ -811,7 +837,7 @@
 		// System.out.println("OK? "+ TokenizerClasses.loadFromNode((Element) tokenizer));
 	}
 	
-	public static boolean loadFromProject(ProjectScope projectScope) {
+	public boolean loadFromProject(ProjectScope projectScope) {
 		// load params
 		IEclipsePreferences params = projectScope.getNode("Tokenizer");
 		
Index: tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/SimpleStringTokenizer.groovy
===================================================================
--- tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/SimpleStringTokenizer.groovy	(revision 3060)
+++ tmp/org.txm.tokenizer.core/src/org/txm/tokenizer/SimpleStringTokenizer.groovy	(revision 3061)
@@ -31,13 +31,13 @@
 public class SimpleStringTokenizer implements StringTokenizer {
 	
 	/** The punct_strong. */
-	String punct_strong = TokenizerClasses.punct_strong;
+	String punct_strong;
 	
 	/** The punct_all. */
-	String punct_all = TokenizerClasses.punct_all;
+	String punct_all;
 	
 	/** The word_chars. */
-	String word_chars = TokenizerClasses.word_chars;
+	String word_chars;
 	
 	String fclitics = null; // default behavior don't manage clitics
 	
@@ -66,36 +66,48 @@
 	
 	Pattern regSplitWhiteSpaces;
 	
+	TokenizerClasses tc;
+	
 	/**
 	 * Instantiates a new simple string tokenizer.
 	 *
 	 * @param lang
 	 */
 	public SimpleStringTokenizer(String lang) {
-		this.lang = lang;
+		this(new TokenizerClasses(lang))
+	}
+	
+	/**
+	 * Instantiates a new simple string tokenizer.
+	 *
+	 * @param lang
+	 */
+	public SimpleStringTokenizer(TokenizerClasses tc) {
+		this.tc = tc
+		this.lang = tc.lang;
 		if (lang != null)
 			if (lang.startsWith("en")) {
-				fclitics = TokenizerClasses.FClitic_en;
+				fclitics = tc.FClitic_en;
 			} else if (lang.startsWith("fr")) {
-				fclitics = TokenizerClasses.FClitic_fr;
-				pclitics = TokenizerClasses.PClitic_fr;
+				fclitics = tc.FClitic_fr;
+				pclitics = tc.PClitic_fr;
 			} else if (lang.startsWith("gl")) {
-				fclitics = TokenizerClasses.FClitic_gl;
+				fclitics = tc.FClitic_gl;
 			} else if (lang.startsWith("it")) {
-				pclitics = TokenizerClasses.PClitic_it;
+				pclitics = tc.PClitic_it;
 			}
 		
-		punct_strong = TokenizerClasses.punct_strong;
-		punct_all = TokenizerClasses.punct_all;
-		word_chars = TokenizerClasses.word_chars;
+		punct_strong = tc.punct_strong;
+		punct_all = tc.punct_all;
+		word_chars = tc.word_chars;
 		
-		String strRegElision = TokenizerClasses.regElision;
+		String strRegElision = tc.regElision;
 		if (strRegElision != null && strRegElision.length() > 0) {
 			regElision = ~/^([\p{L}-]++${strRegElision}[\p{L}-]++)(.*)$/ // the test must start with the start of string  ^
 		}
 		reg3pts = ~/^(.*?)(\.\.\.)(.*)$/
 		
-		String strRegPunct = TokenizerClasses.regPunct;
+		String strRegPunct = tc.regPunct;
 		if (strRegPunct != null && strRegPunct.length() > 0) {
 			regPunct = ~/^(.*?)($strRegPunct)(.*)$/
 		}
@@ -105,12 +117,12 @@
 		if (pclitics != null && pclitics.length() > 0)
 			regPClitics = /^($pclitics)(.*)/ // the test must start with the start of string  ^
 		
-		if (TokenizerClasses.whitespaces != null && TokenizerClasses.whitespaces.length() > 0) {
-			regWhitespaces = ~TokenizerClasses.whitespaces;
+		if (tc.whitespaces != null && tc.whitespaces.length() > 0) {
+			regWhitespaces = ~tc.whitespaces;
 		}
 		
-		if (TokenizerClasses.whitespaces != null && TokenizerClasses.whitespaces.length() > 0) {
-			regSplitWhiteSpaces = Pattern.compile(TokenizerClasses.whitespaces);
+		if (tc.whitespaces != null && tc.whitespaces.length() > 0) {
+			regSplitWhiteSpaces = Pattern.compile(tc.whitespaces);
 		}
 	}
 	
@@ -160,7 +172,7 @@
 	public String standardChecks(ArrayList<String> result, String s) {
 		Matcher m;
 		
-		for (TTest test : TokenizerClasses.tests) {
+		for (TTest test : tc.tests) {
 			if ((m = s =~ test.regex)) {
 				if (DEBUG) {println "test : "+test.regex}
 				if (test.before > 0) {
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/SendConcordanceToTIGERSearch.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/SendConcordanceToTIGERSearch.java	(revision 0)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/SendConcordanceToTIGERSearch.java	(revision 3061)
@@ -0,0 +1,141 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.concordance.rcp.handlers;
+
+import java.util.List;
+
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.StructuredSelection;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.concordance.core.functions.Concordance;
+import org.txm.concordance.core.functions.Line;
+import org.txm.core.results.TXMResult;
+import org.txm.links.rcp.handlers.SendSelectionToQueryable;
+import org.txm.rcp.editors.TXMEditor;
+import org.txm.searchengine.core.IQuery;
+import org.txm.searchengine.core.Selection;
+import org.txm.searchengine.cqp.corpus.CQPCorpus;
+
+/**
+ * Sends the selected lines of a concordance to compute a TIGERSearch command.
+ * 
+ * @author mdecorde
+ * 
+ */
+public class SendConcordanceToTIGERSearch extends SendSelectionToQueryable {
+	
+	public Concordance getConcordance(ExecutionEvent event, ISelection selection) {
+		if (selection instanceof StructuredSelection) {
+			StructuredSelection sselection = (StructuredSelection) selection;
+			List<?> list = sselection.toList();
+			if (list.size() == 0) return null;
+			Object o = list.get(0);
+			if (!(o instanceof org.txm.concordance.core.functions.Line)) return null;
+			Line line = (Line) o;
+			return line.getConcordance();
+		}
+		else {
+			return null;
+		}
+	}
+	
+	@Override
+	public String createQuery(ExecutionEvent event, ISelection selection) {
+		Concordance concordance = getConcordance(event, selection);
+		if (concordance == null) return "";
+		
+		StructuredSelection sselection = (StructuredSelection) selection;
+		List<?> list = sselection.toList();
+		IQuery query = concordance.getQuery();
+		String engine = query.getSearchEngine().getName();
+		if ("TIGER".equals(engine)) {
+			return query.getQueryString(); // TODO the command must also set the current shown graph
+		}
+		else { // use the pivot word IDs
+			StringBuilder buffer = new StringBuilder();
+			buffer.append("[editionId=/");
+			for (int i = 0; i < list.size(); i++) {
+				Line line = (Line) list.get(i);
+				if (line.getMatch().size() == 0) continue; // avoid NPE later
+				
+				if (i > 0) buffer.append("|");
+				buffer.append(line.getKeywordIds().get(0));
+			}
+			buffer.append("/]");
+			return buffer.toString();
+		}
+	}
+	
+	@Override
+	public Integer getIndexResult(ExecutionEvent event, ISelection selection) {
+		Concordance concordance = getConcordance(event, selection);
+		if (concordance == null) return null;
+		
+		IQuery query = concordance.getQuery();
+		String engine = query.getSearchEngine().getName();
+		if ("TIGER".equals(engine)) {
+			return concordance.getTopIndex(); // TODO the command must also set the current shown graph
+		}
+		else {
+			return null;
+		}
+	}
+	
+	@Override
+	public Integer getSubIndexResult(ExecutionEvent event, ISelection selection) {
+		Concordance concordance = getConcordance(event, selection);
+		if (concordance == null) return 0;
+		
+		IQuery query = concordance.getQuery();
+		String engine = query.getSearchEngine().getName();
+		if ("TIGER".equals(engine)) {
+			return null; // TODO the command must also set the current shown graph
+		}
+		else {
+			return null;
+		}
+	}
+	
+	@Override
+	public String createQueries(ExecutionEvent event, ISelection selection) {
+		return null;
+	}
+	
+	@Override
+	public TXMResult getResultParent(ExecutionEvent event) {
+		@SuppressWarnings("unchecked")
+		TXMEditor<Concordance> editor = (TXMEditor<Concordance>) HandlerUtil.getActiveWorkbenchWindow(event).getActivePage().getActivePart();
+		
+		TXMResult result = editor.getResult();
+		Concordance concordance = (Concordance) result;
+		CQPCorpus corpus = CQPCorpus.getFirstParentCorpus(concordance);
+		
+		return corpus;
+	}
+}

Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3060)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3061)
@@ -60,8 +60,6 @@
 import org.eclipse.swt.events.SelectionAdapter;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
-import org.eclipse.swt.graphics.Font;
-import org.eclipse.swt.graphics.FontData;
 import org.eclipse.swt.graphics.GC;
 import org.eclipse.swt.graphics.Point;
 import org.eclipse.swt.graphics.Rectangle;
@@ -72,7 +70,6 @@
 import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Event;
 import org.eclipse.swt.widgets.Label;
 import org.eclipse.swt.widgets.Listener;
@@ -83,7 +80,6 @@
 import org.eclipse.swt.widgets.Table;
 import org.eclipse.swt.widgets.TableColumn;
 import org.eclipse.swt.widgets.TableItem;
-import org.eclipse.swt.widgets.Text;
 import org.eclipse.ui.IEditorInput;
 import org.eclipse.ui.IEditorSite;
 import org.eclipse.ui.IWorkbenchPartSite;
@@ -95,9 +91,9 @@
 import org.txm.concordance.core.functions.comparators.LexicographicLeftContextComparator;
 import org.txm.concordance.core.functions.comparators.LexicographicRightContextComparator;
 import org.txm.concordance.core.functions.comparators.LineComparator;
-import org.txm.concordance.core.functions.comparators.WordPositionComparator;
 import org.txm.concordance.core.functions.comparators.PropertiesReferenceComparator;
 import org.txm.concordance.core.functions.comparators.ReverseComparator;
+import org.txm.concordance.core.functions.comparators.WordPositionComparator;
 import org.txm.concordance.core.preferences.ConcordancePreferences;
 import org.txm.concordance.rcp.actions.DefineSortReferencePattern;
 import org.txm.concordance.rcp.actions.DefineViewReferencePattern;
@@ -111,7 +107,6 @@
 import org.txm.concordance.rcp.widgets.ComplexSortSelector;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.results.Parameter;
-import org.txm.core.results.TXMResult;
 import org.txm.objects.Page;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.JobsTimer;
@@ -122,10 +117,8 @@
 import org.txm.rcp.editors.listeners.ComputeKeyListener;
 import org.txm.rcp.editors.listeners.ComputeSelectionListener;
 import org.txm.rcp.messages.TXMUIMessages;
-import org.txm.rcp.preferences.RCPPreferences;
 import org.txm.rcp.swt.GLComposite;
 import org.txm.rcp.swt.widget.AssistedChoiceQueryWidget;
-import org.txm.rcp.swt.widget.AssistedQueryWidget;
 import org.txm.rcp.swt.widget.NavigationWidget;
 import org.txm.rcp.swt.widget.PropertiesSelector;
 import org.txm.rcp.swt.widget.ReferencePatternSelector;
Index: tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 3060)
+++ tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 3061)
@@ -6,9 +6,9 @@
 Bundle-SymbolicName: org.txm.concordance.rcp;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Bundle-Name: %Bundle-Name
-Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexpor
- t,org.txm.concordance.core;bundle-version="1.0.0";visibility:=reexpor
- t
+Require-Bundle: org.txm.rcp;bundle-version="0.8.0";visibility:=reexport,
+ org.txm.concordance.core;bundle-version="1.0.0";visibility:=reexport,
+ org.txm.links.rcp;bundle-version="1.0.0";visibility:=reexport
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
 Bundle-Vendor: Textometrie.org
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/preferences/AdvancedPreferencePage.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/preferences/AdvancedPreferencePage.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/preferences/AdvancedPreferencePage.java	(revision 3061)
@@ -27,12 +27,10 @@
 //
 package org.txm.rcp.preferences;
 
-import java.io.File;
 import java.util.logging.Level;
 
 import org.eclipse.jface.preference.BooleanFieldEditor;
 import org.eclipse.jface.preference.ComboFieldEditor;
-import org.eclipse.jface.preference.DirectoryFieldEditor;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.layout.GridData;
@@ -53,18 +51,19 @@
  */
 public class AdvancedPreferencePage extends TXMPreferencePage {
 	
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
 	 */
 	@Override
 	protected void createFieldEditors() {
-
+		
 		// install directory
-		//addField(new DirectoryFieldEditor(TBXPreferences.INSTALL_DIR, TXMUIMessages.tXMInstallDirectory, getFieldEditorParent()));
+		// addField(new DirectoryFieldEditor(TBXPreferences.INSTALL_DIR, TXMUIMessages.tXMInstallDirectory, getFieldEditorParent()));
 		
 		// txmhome directory
-		//addField(new DirectoryFieldEditor(TBXPreferences.USER_TXM_HOME, TXMUIMessages.tXMUserDirectory, getFieldEditorParent()));
+		// addField(new DirectoryFieldEditor(TBXPreferences.USER_TXM_HOME, TXMUIMessages.tXMUserDirectory, getFieldEditorParent()));
 		
 		Group updateGroup = new Group(getFieldEditorParent(), SWT.NONE);
 		updateGroup.setText(TXMUIMessages.logs);
@@ -88,7 +87,7 @@
 		choices[7][0] = choices[7][1] = "FINEST"; //$NON-NLS-1$
 		choices[8][0] = choices[8][1] = "ALL"; //$NON-NLS-1$
 		addField(new ComboFieldEditor(TBXPreferences.LOG_LEVEL, TXMUIMessages.logLevel, choices, updateGroup));
-
+		
 		// Log timings
 		addField(new BooleanFieldEditor(TBXPreferences.SHOW_TIMINGS, TXMUIMessages.displayRuntimesInConsole, updateGroup));
 		
@@ -100,24 +99,22 @@
 		
 		// Show dialog on severe error
 		addField(new BooleanFieldEditor(RCPPreferences.SHOW_SEVERE_DIALOG, "Show a dialog box when a severe error occurs", updateGroup));
-
+		
 		// Log in file
 		addField(new BooleanFieldEditor(TBXPreferences.LOG_IN_FILE, TXMUIMessages.logInAFile, updateGroup));
 		
 		// Update level
 		String[][] choices2 = new String[4][2];
-		choices2[0][0] = choices2[0][1]= "STABLE"; //$NON-NLS-1$
+		choices2[0][0] = choices2[0][1] = "STABLE"; //$NON-NLS-1$
 		choices2[1][0] = choices2[1][1] = "BETA"; //$NON-NLS-1$
 		choices2[2][0] = choices2[2][1] = "ALPHA"; //$NON-NLS-1$
 		choices2[3][0] = choices2[3][1] = "DEV"; //$NON-NLS-1$
-		addField(new ComboFieldEditor(RCPPreferences.UPDATE_LEVEL, TXMUIMessages.updateLevel,choices2, getFieldEditorParent()));
+		addField(new ComboFieldEditor(RCPPreferences.UPDATE_LEVEL, TXMUIMessages.updateLevel, choices2, getFieldEditorParent()));
 		
-		// Expert mode
-		addField(new BooleanFieldEditor(TBXPreferences.EXPERT_USER, TXMUIMessages.advancedUserMode, getFieldEditorParent()));
-
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#performOk()
 	 */
 	@Override
@@ -128,26 +125,27 @@
 			MacroExplorer.refresh();
 			CorporaView.refresh();
 			
-			//update the Logger options
+			// update the Logger options
 			Log.setLevel(Level.parse(Toolbox.getPreference(TBXPreferences.LOG_LEVEL)));
 			Log.setPrintInConsole(TBXPreferences.getInstance().getBoolean(TBXPreferences.ADD_TECH_LOGS));
-
+			
 			Log.log_stacktrace_boolean = TBXPreferences.getInstance().getBoolean(TBXPreferences.LOG_STACKTRACE);
 			
 			boolean log_in_file = TBXPreferences.getInstance().getBoolean(TBXPreferences.LOG_IN_FILE);
 			String file = Log.setPrintInFile(log_in_file);
 			
 			// update repositories
-			IHandlerService service = (IHandlerService) PlatformUI.getWorkbench().getService(IHandlerService.class);
+			IHandlerService service = PlatformUI.getWorkbench().getService(IHandlerService.class);
 			service.executeCommand("org.txm.rcp.p2.plugins.FixUpdateHandler", null); //$NON-NLS-1$
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			System.err.println(NLS.bind(TXMUIMessages.failedToSavePreferencesColonP0, e));
 		}
 		return true;
 	}
-
+	
 	@Override
 	public void init(IWorkbench workbench) {
 		this.setPreferenceStore(new TXMPreferenceStore(TBXPreferences.getInstance().getPreferencesNodeQualifier()));
 	}
-}
\ No newline at end of file
+}
